defmodule Derivantes.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    children = [
      DerivantesWeb.Telemetry,
      Derivantes.Repo,
      Derivantes.TdsRepo,
      {DNSCluster, query: Application.get_env(:derivantes, :dns_cluster_query) || :ignore},
      {Phoenix.PubSub, name: Derivantes.PubSub},
      # Start the Finch HTTP client for sending emails
      {Finch, name: Derivantes.Finch},
      # Start a worker by calling: Derivantes.Worker.start_link(arg)
      # {Derivantes.Worker, arg},
      # Start to serve requests, typically the last entry
      DerivantesWeb.Endpoint
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Derivantes.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    DerivantesWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
